; 

    .486                      ; force 32 bit code
    .model flat, stdcall      ; memory model & calling convention
    option casemap :none      ; case sensitive

    test_data PROTO :DWORD,:DWORD

    BCNT  equ <12>
    tchar equ <BYTE  PTR [ecx]>
    lnode equ <DWORD PTR [ecx+4]>
    rnode equ <DWORD PTR [ecx+8]>

    .code

; 

align 4

test_data proc txt:DWORD,hmem:DWORD

    xor eax, eax
    mov edx, txt
    mov ecx, hmem
    jmp strt

  align 4
  pre:
    add edx, 1
  strt:
    mov al, [edx]

  ; =====================
    .if al != 0
      nonzero:
      .if tchar == al
        mov ecx, lnode              ; move up left node
        test ecx, ecx
        jnz pre
        jmp notfound
      .else
        mov ecx, rnode              ; move across right node
        test ecx, ecx
        jnz nonzero
        jmp notfound
      .endif
  ; =====================
    .else                           ; if al == 0
      zero:
      .if lnode != 0 && tchar != 0
        mov ecx, rnode
        jmp zero
      .else
        mov eax, lnode              ; load left node into EAX and exit
        jmp quit
      .endif
    .endif
  ; =====================

    jmp quit

  notfound:
    mov eax, -1                     ; return -1 on word not found

  quit:
    ret

test_data endp

; 

end
